/*----- PROTECTED REGION ID(Acs16Class.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id: Acs16Class.cpp,v 1.6 2014-09-10 13:56:57 alessio Exp $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source: /home/cvsadm/cvsroot/fermi/servers/acs16/src/Acs16Class.cpp,v $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        Acs16Class.cpp
//
// description : C++ source for the Acs16Class.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the Acs16 once per process.
//
// project :     avocent acs16
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.6 $
// $Date: 2014-09-10 13:56:57 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <tango.h>
#include <Acs16.h>
#include <Acs16Class.h>

/*----- PROTECTED REGION END -----*/	//	Acs16Class.cpp

//-------------------------------------------------------------------
/**
 *	Create Acs16Class singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Acs16_class(const char *name) {
		return Acs16_ns::Acs16Class::init(name);
	}
}

namespace Acs16_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
Acs16Class *Acs16Class::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		Acs16Class::Acs16Class(string &s)
 * description : 	constructor for the Acs16Class
 *
 * @param s	The class name
 */
//--------------------------------------------------------
Acs16Class::Acs16Class(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering Acs16Class constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(Acs16Class::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16Class::constructor

	cout2 << "Leaving Acs16Class constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		Acs16Class::~Acs16Class()
 * description : 	destructor for the Acs16Class
 */
//--------------------------------------------------------
Acs16Class::~Acs16Class()
{
	/*----- PROTECTED REGION ID(Acs16Class::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16Class::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		Acs16Class::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
Acs16Class *Acs16Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new Acs16Class(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}		
	}		
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		Acs16Class::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
Acs16Class *Acs16Class::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		DevSerFlushClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevSerFlushClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DevSerFlushClass::execute(): arrived" << endl;
	Tango::DevLong argin;
	extract(in_any, argin);
	((static_cast<Acs16 *>(device))->dev_ser_flush(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DevSerGetNCharClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevSerGetNCharClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "DevSerGetNCharClass::execute(): arrived" << endl;
	return insert((static_cast<Acs16 *>(device))->dev_ser_get_nchar());
}

//--------------------------------------------------------
/**
 * method : 		DevSerReadCharClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevSerReadCharClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DevSerReadCharClass::execute(): arrived" << endl;
	Tango::DevLong argin;
	extract(in_any, argin);
	return insert((static_cast<Acs16 *>(device))->dev_ser_read_char(argin));
}

//--------------------------------------------------------
/**
 * method : 		DevSerReadLineClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevSerReadLineClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "DevSerReadLineClass::execute(): arrived" << endl;
	return insert((static_cast<Acs16 *>(device))->dev_ser_read_line());
}

//--------------------------------------------------------
/**
 * method : 		DevSerReadNCharClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevSerReadNCharClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DevSerReadNCharClass::execute(): arrived" << endl;
	Tango::DevLong argin;
	extract(in_any, argin);
	return insert((static_cast<Acs16 *>(device))->dev_ser_read_nchar(argin));
}

//--------------------------------------------------------
/**
 * method : 		DevSerReadRawClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevSerReadRawClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "DevSerReadRawClass::execute(): arrived" << endl;
	return insert((static_cast<Acs16 *>(device))->dev_ser_read_raw());
}

//--------------------------------------------------------
/**
 * method : 		DevSerReadRetryClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevSerReadRetryClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DevSerReadRetryClass::execute(): arrived" << endl;
	Tango::DevLong argin;
	extract(in_any, argin);
	return insert((static_cast<Acs16 *>(device))->dev_ser_read_retry(argin));
}

//--------------------------------------------------------
/**
 * method : 		DevSerReadStringClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevSerReadStringClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DevSerReadStringClass::execute(): arrived" << endl;
	Tango::DevLong argin;
	extract(in_any, argin);
	return insert((static_cast<Acs16 *>(device))->dev_ser_read_string(argin));
}

//--------------------------------------------------------
/**
 * method : 		DevSerSetBaudrateClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevSerSetBaudrateClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DevSerSetBaudrateClass::execute(): arrived" << endl;
	Tango::DevULong argin;
	extract(in_any, argin);
	((static_cast<Acs16 *>(device))->dev_ser_set_baudrate(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DevSerSetCharLengthClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevSerSetCharLengthClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DevSerSetCharLengthClass::execute(): arrived" << endl;
	Tango::DevShort argin;
	extract(in_any, argin);
	((static_cast<Acs16 *>(device))->dev_ser_set_char_length(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DevSerSetNewlineClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevSerSetNewlineClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DevSerSetNewlineClass::execute(): arrived" << endl;
	Tango::DevShort argin;
	extract(in_any, argin);
	((static_cast<Acs16 *>(device))->dev_ser_set_newline(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DevSerSetParameterClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevSerSetParameterClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DevSerSetParameterClass::execute(): arrived" << endl;
	const Tango::DevVarLongArray *argin;
	extract(in_any, argin);
	((static_cast<Acs16 *>(device))->dev_ser_set_parameter(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DevSerSetParityClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevSerSetParityClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DevSerSetParityClass::execute(): arrived" << endl;
	Tango::DevShort argin;
	extract(in_any, argin);
	((static_cast<Acs16 *>(device))->dev_ser_set_parity(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DevSerSetStopbitClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevSerSetStopbitClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DevSerSetStopbitClass::execute(): arrived" << endl;
	Tango::DevShort argin;
	extract(in_any, argin);
	((static_cast<Acs16 *>(device))->dev_ser_set_stopbit(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DevSerSetTimeoutClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevSerSetTimeoutClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DevSerSetTimeoutClass::execute(): arrived" << endl;
	Tango::DevShort argin;
	extract(in_any, argin);
	((static_cast<Acs16 *>(device))->dev_ser_set_timeout(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DevSerWriteCharClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevSerWriteCharClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DevSerWriteCharClass::execute(): arrived" << endl;
	const Tango::DevVarCharArray *argin;
	extract(in_any, argin);
	return insert((static_cast<Acs16 *>(device))->dev_ser_write_char(argin));
}

//--------------------------------------------------------
/**
 * method : 		DevSerWriteStringClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevSerWriteStringClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DevSerWriteStringClass::execute(): arrived" << endl;
	Tango::DevString argin;
	extract(in_any, argin);
	return insert((static_cast<Acs16 *>(device))->dev_ser_write_string(argin));
}

//--------------------------------------------------------
/**
 * method : 		WriteReadClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *WriteReadClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "WriteReadClass::execute(): arrived" << endl;
	const Tango::DevVarLongStringArray *argin;
	extract(in_any, argin);
	return insert((static_cast<Acs16 *>(device))->write_read(argin));
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : Acs16Class::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum Acs16Class::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Acs16Class::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum Acs16Class::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Acs16Class::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum Acs16Class::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Acs16Class::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void Acs16Class::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "PortNumber";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "HostName";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Timeout";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "NewLineChar";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "BufferSize";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : Acs16Class::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void Acs16Class::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("avocent acs16");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);

	//	put cvs or svn location
	string	filename("Acs16");
	filename += "Class.cpp";

	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : Acs16Class::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void Acs16Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(Acs16Class::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Acs16Class::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new Acs16(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Acs16 *dev = static_cast<Acs16 *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(Acs16Class::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Acs16Class::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Acs16Class::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void Acs16Class::attribute_factory(TANGO_UNUSED(vector<Tango::Attr *> &att_list))
{
	/*----- PROTECTED REGION ID(Acs16Class::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Acs16Class::attribute_factory_before
	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(Acs16Class::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Acs16Class::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Acs16Class::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void Acs16Class::command_factory()
{
	/*----- PROTECTED REGION ID(Acs16Class::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Acs16Class::command_factory_before


	//	Command DevSerFlush
	DevSerFlushClass	*pDevSerFlushCmd =
		new DevSerFlushClass("DevSerFlush",
			Tango::DEV_LONG, Tango::DEV_VOID,
			"flush to do 0=input 1=output 2=both",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pDevSerFlushCmd);

	//	Command DevSerGetNChar
	DevSerGetNCharClass	*pDevSerGetNCharCmd =
		new DevSerGetNCharClass("DevSerGetNChar",
			Tango::DEV_VOID, Tango::DEV_LONG,
			"no argin",
			"number of char available in receiving buffer",
			Tango::OPERATOR);
	command_list.push_back(pDevSerGetNCharCmd);

	//	Command DevSerReadChar
	DevSerReadCharClass	*pDevSerReadCharCmd =
		new DevSerReadCharClass("DevSerReadChar",
			Tango::DEV_LONG, Tango::DEVVAR_CHARARRAY,
			"type of read SL_RAW SL_NCHAR SL_LINE",
			"Array of characters read",
			Tango::OPERATOR);
	command_list.push_back(pDevSerReadCharCmd);

	//	Command DevSerReadLine
	DevSerReadLineClass	*pDevSerReadLineCmd =
		new DevSerReadLineClass("DevSerReadLine",
			Tango::DEV_VOID, Tango::DEV_STRING,
			"no argin",
			"pointer to the string read updated",
			Tango::OPERATOR);
	command_list.push_back(pDevSerReadLineCmd);

	//	Command DevSerReadNChar
	DevSerReadNCharClass	*pDevSerReadNCharCmd =
		new DevSerReadNCharClass("DevSerReadNChar",
			Tango::DEV_LONG, Tango::DEV_STRING,
			"number of the caracters to read on the serial line",
			"pointer to the string read updated",
			Tango::OPERATOR);
	command_list.push_back(pDevSerReadNCharCmd);

	//	Command DevSerReadRaw
	DevSerReadRawClass	*pDevSerReadRawCmd =
		new DevSerReadRawClass("DevSerReadRaw",
			Tango::DEV_VOID, Tango::DEV_STRING,
			"no argin",
			"pointer to the string read updated",
			Tango::OPERATOR);
	command_list.push_back(pDevSerReadRawCmd);

	//	Command DevSerReadRetry
	DevSerReadRetryClass	*pDevSerReadRetryCmd =
		new DevSerReadRetryClass("DevSerReadRetry",
			Tango::DEV_LONG, Tango::DEV_STRING,
			"number of reading retries",
			"pointer to the string read updated",
			Tango::OPERATOR);
	command_list.push_back(pDevSerReadRetryCmd);

	//	Command DevSerReadString
	DevSerReadStringClass	*pDevSerReadStringCmd =
		new DevSerReadStringClass("DevSerReadString",
			Tango::DEV_LONG, Tango::DEV_STRING,
			"type of read SL_RAW SL_NCHAR SL_LINE",
			"String read",
			Tango::OPERATOR);
	command_list.push_back(pDevSerReadStringCmd);

	//	Command DevSerSetBaudrate
	DevSerSetBaudrateClass	*pDevSerSetBaudrateCmd =
		new DevSerSetBaudrateClass("DevSerSetBaudrate",
			Tango::DEV_ULONG, Tango::DEV_VOID,
			"The new baudrate to set",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pDevSerSetBaudrateCmd);

	//	Command DevSerSetCharLength
	DevSerSetCharLengthClass	*pDevSerSetCharLengthCmd =
		new DevSerSetCharLengthClass("DevSerSetCharLength",
			Tango::DEV_SHORT, Tango::DEV_VOID,
			"The new charlength to set",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pDevSerSetCharLengthCmd);

	//	Command DevSerSetNewline
	DevSerSetNewlineClass	*pDevSerSetNewlineCmd =
		new DevSerSetNewlineClass("DevSerSetNewline",
			Tango::DEV_SHORT, Tango::DEV_VOID,
			"The new line character to set",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pDevSerSetNewlineCmd);

	//	Command DevSerSetParameter
	DevSerSetParameterClass	*pDevSerSetParameterCmd =
		new DevSerSetParameterClass("DevSerSetParameter",
			Tango::DEVVAR_LONGARRAY, Tango::DEV_VOID,
			"device parameters in pair",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pDevSerSetParameterCmd);

	//	Command DevSerSetParity
	DevSerSetParityClass	*pDevSerSetParityCmd =
		new DevSerSetParityClass("DevSerSetParity",
			Tango::DEV_SHORT, Tango::DEV_VOID,
			"The new parity to set.",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pDevSerSetParityCmd);

	//	Command DevSerSetStopbit
	DevSerSetStopbitClass	*pDevSerSetStopbitCmd =
		new DevSerSetStopbitClass("DevSerSetStopbit",
			Tango::DEV_SHORT, Tango::DEV_VOID,
			"The new stopbit to set",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pDevSerSetStopbitCmd);

	//	Command DevSerSetTimeout
	DevSerSetTimeoutClass	*pDevSerSetTimeoutCmd =
		new DevSerSetTimeoutClass("DevSerSetTimeout",
			Tango::DEV_SHORT, Tango::DEV_VOID,
			"Value of the timeout to set",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pDevSerSetTimeoutCmd);

	//	Command DevSerWriteChar
	DevSerWriteCharClass	*pDevSerWriteCharCmd =
		new DevSerWriteCharClass("DevSerWriteChar",
			Tango::DEVVAR_CHARARRAY, Tango::DEV_LONG,
			"Characters to write",
			"Number of characters written",
			Tango::OPERATOR);
	command_list.push_back(pDevSerWriteCharCmd);

	//	Command DevSerWriteString
	DevSerWriteStringClass	*pDevSerWriteStringCmd =
		new DevSerWriteStringClass("DevSerWriteString",
			Tango::DEV_STRING, Tango::DEV_LONG,
			"String to write",
			"Number of characters written",
			Tango::OPERATOR);
	command_list.push_back(pDevSerWriteStringCmd);

	//	Command WriteRead
	WriteReadClass	*pWriteReadCmd =
		new WriteReadClass("WriteRead",
			Tango::DEVVAR_LONGSTRINGARRAY, Tango::DEV_STRING,
			"type of reading strategy(RAW,NCHAR..),command to write on the port com",
			"response of the device behind the serial line",
			Tango::OPERATOR);
	command_list.push_back(pWriteReadCmd);

	/*----- PROTECTED REGION ID(Acs16Class::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Acs16Class::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		Acs16Class::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list 
 */
//--------------------------------------------------------
void Acs16Class::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(Acs16Class::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16Class::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		Acs16Class::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void Acs16Class::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{	
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		Acs16 *dev = static_cast<Acs16 *> (dev_impl);
		
		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(Acs16Class::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16Class::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : Acs16Class::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *Acs16Class::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; it++)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(Acs16Class::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	Acs16Class::Additional Methods
} //	namespace
