/*----- PROTECTED REGION ID(Acs16StateMachine.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: Acs16StateMachine.cpp,v 1.4 2014-09-10 13:33:58 alessio Exp $";
//=============================================================================
//
// file :        Acs16StateMachine.cpp
//
// description : State machine file for the Acs16 class
//
// project :     avocent acs16
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.4 $
// $Date: 2014-09-10 13:33:58 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <Acs16.h>

/*----- PROTECTED REGION END -----*/	//	Acs16::Acs16StateMachine.cpp

//================================================================
//  States  |  Description
//================================================================


namespace Acs16_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_DevSerFlush_allowed()
 *	Description : Execution allowed for DevSerFlush attribute
 */
//--------------------------------------------------------
bool Acs16::is_DevSerFlush_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DevSerFlush command.
	/*----- PROTECTED REGION ID(Acs16::DevSerFlushStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::DevSerFlushStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_DevSerGetNChar_allowed()
 *	Description : Execution allowed for DevSerGetNChar attribute
 */
//--------------------------------------------------------
bool Acs16::is_DevSerGetNChar_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DevSerGetNChar command.
	/*----- PROTECTED REGION ID(Acs16::DevSerGetNCharStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::DevSerGetNCharStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_DevSerReadChar_allowed()
 *	Description : Execution allowed for DevSerReadChar attribute
 */
//--------------------------------------------------------
bool Acs16::is_DevSerReadChar_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DevSerReadChar command.
	/*----- PROTECTED REGION ID(Acs16::DevSerReadCharStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::DevSerReadCharStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_DevSerReadLine_allowed()
 *	Description : Execution allowed for DevSerReadLine attribute
 */
//--------------------------------------------------------
bool Acs16::is_DevSerReadLine_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DevSerReadLine command.
	/*----- PROTECTED REGION ID(Acs16::DevSerReadLineStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::DevSerReadLineStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_DevSerReadNChar_allowed()
 *	Description : Execution allowed for DevSerReadNChar attribute
 */
//--------------------------------------------------------
bool Acs16::is_DevSerReadNChar_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DevSerReadNChar command.
	/*----- PROTECTED REGION ID(Acs16::DevSerReadNCharStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::DevSerReadNCharStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_DevSerReadRaw_allowed()
 *	Description : Execution allowed for DevSerReadRaw attribute
 */
//--------------------------------------------------------
bool Acs16::is_DevSerReadRaw_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DevSerReadRaw command.
	/*----- PROTECTED REGION ID(Acs16::DevSerReadRawStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::DevSerReadRawStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_DevSerReadRetry_allowed()
 *	Description : Execution allowed for DevSerReadRetry attribute
 */
//--------------------------------------------------------
bool Acs16::is_DevSerReadRetry_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DevSerReadRetry command.
	/*----- PROTECTED REGION ID(Acs16::DevSerReadRetryStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::DevSerReadRetryStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_DevSerReadString_allowed()
 *	Description : Execution allowed for DevSerReadString attribute
 */
//--------------------------------------------------------
bool Acs16::is_DevSerReadString_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DevSerReadString command.
	/*----- PROTECTED REGION ID(Acs16::DevSerReadStringStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::DevSerReadStringStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_DevSerSetBaudrate_allowed()
 *	Description : Execution allowed for DevSerSetBaudrate attribute
 */
//--------------------------------------------------------
bool Acs16::is_DevSerSetBaudrate_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DevSerSetBaudrate command.
	/*----- PROTECTED REGION ID(Acs16::DevSerSetBaudrateStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::DevSerSetBaudrateStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_DevSerSetCharLength_allowed()
 *	Description : Execution allowed for DevSerSetCharLength attribute
 */
//--------------------------------------------------------
bool Acs16::is_DevSerSetCharLength_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DevSerSetCharLength command.
	/*----- PROTECTED REGION ID(Acs16::DevSerSetCharLengthStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::DevSerSetCharLengthStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_DevSerSetNewline_allowed()
 *	Description : Execution allowed for DevSerSetNewline attribute
 */
//--------------------------------------------------------
bool Acs16::is_DevSerSetNewline_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DevSerSetNewline command.
	/*----- PROTECTED REGION ID(Acs16::DevSerSetNewlineStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::DevSerSetNewlineStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_DevSerSetParameter_allowed()
 *	Description : Execution allowed for DevSerSetParameter attribute
 */
//--------------------------------------------------------
bool Acs16::is_DevSerSetParameter_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DevSerSetParameter command.
	/*----- PROTECTED REGION ID(Acs16::DevSerSetParameterStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::DevSerSetParameterStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_DevSerSetParity_allowed()
 *	Description : Execution allowed for DevSerSetParity attribute
 */
//--------------------------------------------------------
bool Acs16::is_DevSerSetParity_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DevSerSetParity command.
	/*----- PROTECTED REGION ID(Acs16::DevSerSetParityStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::DevSerSetParityStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_DevSerSetStopbit_allowed()
 *	Description : Execution allowed for DevSerSetStopbit attribute
 */
//--------------------------------------------------------
bool Acs16::is_DevSerSetStopbit_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DevSerSetStopbit command.
	/*----- PROTECTED REGION ID(Acs16::DevSerSetStopbitStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::DevSerSetStopbitStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_DevSerSetTimeout_allowed()
 *	Description : Execution allowed for DevSerSetTimeout attribute
 */
//--------------------------------------------------------
bool Acs16::is_DevSerSetTimeout_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DevSerSetTimeout command.
	/*----- PROTECTED REGION ID(Acs16::DevSerSetTimeoutStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::DevSerSetTimeoutStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_DevSerWriteChar_allowed()
 *	Description : Execution allowed for DevSerWriteChar attribute
 */
//--------------------------------------------------------
bool Acs16::is_DevSerWriteChar_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DevSerWriteChar command.
	/*----- PROTECTED REGION ID(Acs16::DevSerWriteCharStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::DevSerWriteCharStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_DevSerWriteString_allowed()
 *	Description : Execution allowed for DevSerWriteString attribute
 */
//--------------------------------------------------------
bool Acs16::is_DevSerWriteString_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DevSerWriteString command.
	/*----- PROTECTED REGION ID(Acs16::DevSerWriteStringStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::DevSerWriteStringStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::is_WriteRead_allowed()
 *	Description : Execution allowed for WriteRead attribute
 */
//--------------------------------------------------------
bool Acs16::is_WriteRead_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for WriteRead command.
	/*----- PROTECTED REGION ID(Acs16::WriteReadStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::WriteReadStateAllowed
	return true;
}

}	//	End of namespace
