/* 
 * File:   Socket.h
 * Author: mdm
 *
 * Created on April 1, 2010, 4:24 PM
 */

#ifndef _SOCKET_H
#define	_SOCKET_H

#include <tango.h>
#include <iostream>
#include <sys/time.h>
//#include <ctime> 
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <omnithread.h>
#include "SocketException.h"

class Socket : public Tango::LogAdapter
{

public:
    Socket(Tango::DeviceImpl * device, const std::string, const int, const long, bool);
    virtual ~Socket();
    void open_socket();
    void close_socket();
    int write(const char*, const int);
    int read(char*, const int);
    long left_to_read();

private:
    void connect_socket(const struct sockaddr*);
    std::string printTime();
    int socketfd;    
    const std::string hostname;
    const int portN;
    const bool try_reconnection;
    struct timeval timeout;
};

#endif	/* _SOCKET_H */

